%global eclipse_base     %{_libdir}/eclipse
%global eclipse_dropin   %{_datadir}/eclipse/dropins

# Note: Use the tag in get-mdt-ocl.sh as the context qualifier because it's
#       later than the tags of the individual plugins.
%global contextQualifier v200909151245

Name:      eclipse-emf-transaction
Version:   1.3.1
Release:   2%{?dist}
Summary:   A model management layer for managing EMF resources
Group:     System Environment/Libraries
License:   EPL
URL:       http://www.eclipse.org/modeling/emf/?project=transaction

# source tarball and the script used to generate it from upstream's source control
# script usage:
# $ sh get-emf-transaction.sh
Source0:   emf-transaction-%{version}.tar.gz
Source1:   get-emf-transaction.sh

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:        noarch

BuildRequires:    java-devel
BuildRequires:    jpackage-utils
BuildRequires:    eclipse-pde >= 1:3.5.1
BuildRequires:    eclipse-emf >= 2.5.0
BuildRequires:    eclipse-emf-query >= 1.3.0
BuildRequires:    eclipse-emf-validation >= 1.3.0
Requires:         java
Requires:         jpackage-utils
Requires:         eclipse-platform >= 1:3.5.1
Requires:         eclipse-emf >= 2.5.0
Requires:         eclipse-emf-query >= 1.3.0
Requires:         eclipse-emf-validation >= 1.3.0

%description
The transaction component provide support for clients to read and write EMF
models on multiple threads, provides automatic validation to detect invalid
changes and provides support for batched notification of related changes,
rather than as a stream of EMF notifications. In particular, this allows
applications to analyze change sets in their entirety. For a simplified
programming model, the API automatically tracks changes applied to models
without the need for client code to use EMF edit commands. These changes are
encapsulated in transactions/operations that can undo and redo themselves.

#TODO - sdk/examples subpackages?

%prep
%setup -q -n emf-transaction-%{version}

# make sure upstream hasn't sneaked in any jars we don't know about
JARS=""
for j in `find -name "*.jar"`; do
  if [ ! -L $j ]; then
    JARS="$JARS $j"
  fi
done
if [ ! -z "$JARS" ]; then
   echo "These jars should be deleted and symlinked to system jars: $JARS"
   exit 1
fi

# remove spurious exec permissions from docs
find -wholename "*/rootfiles/*" | xargs chmod -x

%build
# build emf-transaction features
%{eclipse_base}/buildscripts/pdebuild -f org.eclipse.emf.transaction \
  -d "emf" -a "-DforceContextQualifier=%{contextQualifier}"
%{eclipse_base}/buildscripts/pdebuild -f org.eclipse.emf.workspace \
  -d "emf" -a "-DforceContextQualifier=%{contextQualifier}"

%install
rm -rf %{buildroot}
install -d -m 755 %{buildroot}%{eclipse_dropin}
unzip -q -n -d %{buildroot}%{eclipse_dropin}/emf-transaction build/rpmBuild/org.eclipse.emf.transaction.zip
unzip -q -n -d %{buildroot}%{eclipse_dropin}/emf-transaction build/rpmBuild/org.eclipse.emf.workspace.zip

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{eclipse_dropin}/emf-transaction
%doc org.eclipse.emf.transaction-feature/rootfiles/*

%changelog
* Tue Nov 24 2009 Mat Booth <fedora@matbooth.co.uk> 1.3.1-2
- Don't pretty-print the package description.

* Fri Nov 13 2009 Mat Booth <fedora@matbooth.co.uk> 1.3.1-1
- New transaction spec file based on eclipse-gef.
